#ifndef	___DelayDispatcher_H_
#define	___DelayDispatcher_H_
//------------------------------------------------------------------------------
// BeOS
#include <MessageRunner.h>
#include <Messenger.h>
#include <Handler.h>
// C++
#include <map>
// Add
//------------------------------------------------------------------------------
using namespace	std;
//------------------------------------------------------------------------------
//==============================================================================
class	TDelaySendInfo
{
public:
	int32			mMsgRunnerID;	// メッセージランナーの ID
	BMessage		mMsg;			// 送るべきメッセージ
	BMessageRunner*	mMsgRunner;		// 送るタイミングを通知してくるメッセージランナー
};
//==============================================================================
class	TDelaySender : public BHandler
{
public:
	TDelaySender(const char* oName);
	~TDelaySender();

	status_t	SendMessage(BMessage* oMsg);	// メッセージ送信
	void		SetDelay(bigtime_t oDelay);		// 遅延時間の設定 [μs]
	void		SetTarget(BMessenger oMsger);	// メッセージ送り先の設定

private:
	typedef	BHandler	SUPER;

	void			DelaySenderTimeout(BMessage* oMsg);
	virtual void	MessageReceived(BMessage* oMsg);

	int32		mMsgRunnerIDCnt;			// カウンタ
	bigtime_t	mDelay;						// 遅延時間
	map<uint32, TDelaySendInfo>	mInfoMap;	// メッセージ送信用の情報群
	BMessenger	mTarget;					// メッセージ送り先
};
//==============================================================================
#endif	// ___DelayDispatcher_H_
