#ifndef	___Exception_H_
#define	___Exception_H_
//------------------------------------------------------------------------------
// BeOS
#include <InterfaceDefs.h>
// C++
#include <string>
//==============================================================================
/* ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
例外
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' */
class	TException
{
public:
	TException(uint32 oID, const string& oString = "");
	TException(const string& oString);
	~TException();

	string		String() const;		// 説明を得る
	uint32		ID() const;			// ID を返す

private:
	uint32		mID;				// 例外 ID
	string		mString;			// 内容説明などの文字列
};
//==============================================================================
#endif	// ___Exception_H_
