/*==============================================================================
		アプリケーション内で共有する情報	for Zeta	Ver 1.00
		Copyright (C) 2003 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2003/11/19 (Wed) 開発着手。
 1.00 | 2003/11/19 (Wed) オリジナルバージョン。
==============================================================================*/

/*=== Memo =====================================================================
保存不要な情報を扱う。
==============================================================================*/

//------------------------------------------------------------------------------
#include "AppPrivacy.h"
//------------------------------------------------------------------------------
// BeOS
#include <Entry.h>
#include <Path.h>
// C++
// Add2
#include "StringUtils.h"
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//==============================================================================
TAppPrivacy::TAppPrivacy()
{
}
//------------------------------------------------------------------------------
TAppPrivacy::~TAppPrivacy()
{
}
//------------------------------------------------------------------------------
void	TAppPrivacy::AnalyzeExePath(const char* oAppFName)
{
	BEntry	aRealEntry(oAppFName, true);
	BPath	aRealPath;

	aRealEntry.GetPath(&aRealPath);
	mExeName = extract_file_name(aRealPath.Path());
	mExePath = extract_file_path(aRealPath.Path());
}
//------------------------------------------------------------------------------
string	TAppPrivacy::ExeName()
{
	return mExeName;
}
//------------------------------------------------------------------------------
string	TAppPrivacy::ExePath()
{
	return mExePath;
}
//==============================================================================
//------------------------------------------------------------------------------
//==============================================================================
