/*==============================================================================
		スパイフィルタ	for Zeta	Ver 1.00
		Copyright (C) 2003 by ＳＨＩＮＴＡ
==============================================================================*/

/*==============================================================================
 Ver. |					主な改良点
--------------------------------------------------------------------------------
 ---- | 2003/12/07 (Sun) 開発着手。
 1.00 | 2003/12/07 (Sun) TLanguageChangedFilter を元に構築。
==============================================================================*/

/*=== Memo =====================================================================
==============================================================================*/

//------------------------------------------------------------------------------
#include "SpyFilter.h"
//------------------------------------------------------------------------------
// BeOS
#include <Locale.h>
// C++
// Add2
#include "MiscDebug.h"
//------------------------------------------------------------------------------
const char	MSGNAME_SEND_FLAG[] = "SpySendFlag";
//==============================================================================
TSpyFilter::TSpyFilter(const uint32 oWhat, const BMessenger& oTgtMsger)
		: SUPER(oWhat)
{
	mTgtMsger = oTgtMsger;
}
//------------------------------------------------------------------------------
filter_result	TSpyFilter::Filter(BMessage* oMsg, BHandler** oTgt)
{
	bool		aBool;
	BMessage	aSendMsg(*oMsg);

	if ( oMsg->FindBool(MSGNAME_SEND_FLAG, &aBool) != B_OK ) {
		// メッセージが無限増殖するのを防ぐため、コピー品には印をつけてから送付
		aSendMsg.AddBool(MSGNAME_SEND_FLAG, true);
		mTgtMsger.SendMessage(&aSendMsg);
	}
	return B_DISPATCH_MESSAGE;
}
//==============================================================================
